DECLARE
  l_roles     OWA.VC_ARR;
  l_modules   OWA.VC_ARR;
  l_patterns  OWA.VC_ARR;
BEGIN
  ORDS.ENABLE_SCHEMA(
      p_enabled             => TRUE,
      p_schema              => 'ITSUSTAV',
      p_url_mapping_type    => 'BASE_PATH',
      p_url_mapping_pattern => 'mish',
      p_auto_rest_auth      => FALSE);    
  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_gas',
      p_base_path      => '/pra_pos_gas/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'artikl',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'artikl',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   artikl_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :artikl := PRA_POS_GAS.POSTOJI_ARTIKAL(:artikl_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'artikl',
      p_bind_variable_name => 'artikl',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'artikl',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'cjenik',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'cjenik',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   cjenik_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :cjenik := PRA_POS_GAS.POSTOJI_NACPOT(:cjenik_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'cjenik',
      p_bind_variable_name => 'cjenik',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'cjenik',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'dnevni_obracun/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'dnevni_obracun/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :postoji_dnevni_obracun := PRA_POS_GAS.POSTOJI_DO( TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'postoji_dnevni_obracun',
      p_bind_variable_name => 'postoji_dnevni_obracun',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'dnevni_obracun/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporez',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporez',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   gporez_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :gporez := PRA_POS_GAS.POSTOJI_GPOREZ(:gporez_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'gporez',
      p_bind_variable_name => 'gporez',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporez',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporezi',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'gporezi',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :porezne_grupe := PRA_POS_GAS.GPOREZI;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'porezne_grupe',
      p_bind_variable_name => 'porezne_grupe',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'gporezi',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'jir',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'jir',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE

    -- jir
    l_GODINA VARCHAR2(5);
    l_KASE_ID NUMBER;
    l_RBR VARCHAR2(50);
    l_JIR VARCHAR2(40);
    l_ZASTITNI_KOD VARCHAR2(40);

    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_test VARCHAR2(50);

    l_broj_racuna NUMBER;

    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;
    api_exception exception;

    l_ords_api number := 1.3;

    l_values apex_json.t_values;

    /**
    * POST BODY PARAMETRI:
    *[
		{
			"godina": "2017",
			"kase_id": 5067,
			"rbr": "000009",
			"jir": null,
			"zastitni_kod": null
        }
    ]
        */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    END IF;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);

    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        l_GODINA := apex_json.get_varchar2(p_path => ''[%d].godina'', p0 => racun, p_values => l_values);
        l_KASE_ID := apex_json.get_number(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        l_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        l_ZASTITNI_KOD := apex_json.get_varchar2(p_path => ''[%d].zastitni_kod'', p0 => racun, p_values => l_values);
        l_JIR := apex_json.get_varchar2(p_path => ''[%d].jir'', p0 => racun, p_values => l_values);

        pra_pos_gas.UCITAJ_JIR( l_GODINA,
                                l_KASE_ID,
                                l_RBR,
                                l_ZASTITNI_KOD,
                                l_JIR);
    END LOOP;

    :message := ''Podaci su uspješno upisani '' || l_broj_racuna;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

end;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'jir',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase',
      p_priority       => 0,
      p_etag_type      => 'NONE',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :kase := PRA_POS_GAS.KASE;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'kase',
      p_bind_variable_name => 'kase',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/asortiman',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/asortiman',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :asortiman := PRA_POS_GAS.ASORTIMAN(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'asortiman',
      p_bind_variable_name => 'asortiman',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/asortiman',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    PRA_POS_GAS.AZURIRAJ_OZN_SINKRONIZACIJE(:kasa_id);

    :message := ''Podaci su uspješno izmijenjeni!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :automatska_sinkronizacija := PRA_POS_GAS.AUTOMATSKA_SINKRONIZACIJA(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'automatska_sinkronizacija',
      p_bind_variable_name => 'automatska_sinkronizacija',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/automatska_sinkronizacija',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :cjenici := PRA_POS_GAS.cjenici(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'cjenici',
      p_bind_variable_name => 'cjenici',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vplacanja := PRA_POS_GAS.VPLACANJA(:kasa_id, :cjenik_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'cjenik_id',
      p_bind_variable_name => 'cjenik_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'vrste_placanja',
      p_bind_variable_name => 'vplacanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/cjenici/{cjenik_id}/vplacanja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :konobari := PRA_POS_GAS.konobari(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'konobari',
      p_bind_variable_name => 'konobari',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :cjenici := PRA_POS_GAS.CJENICI_KONOBARA(:konobar_id, :kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'cjenici',
      p_bind_variable_name => 'cjenici',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'konobar_id',
      p_bind_variable_name => 'konobar_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/cjenici',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :dozvole := PRA_POS_GAS.dozvole(:kasa_id, :konobar_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'dozvole',
      p_bind_variable_name => 'dozvole',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'konobar_id',
      p_bind_variable_name => 'konobar_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/konobari/{konobar_id}/dozvole',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/mjesta_troska',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/mjesta_troska',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :mjesta_troska := PRA_POS_GAS.MJESTA_TROSKA(:kasa_id);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'mjesta_troska',
      p_bind_variable_name => 'mjesta_troska',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/mjesta_troska',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    unimplemented_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :nacini_potrosnje := PRA_POS_GAS.NP_LISTA( :kasa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'nacini_potrosnje',
      p_bind_variable_name => 'nacini_potrosnje',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/nacini_potrosnje_za_popust_gosta',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    PRA_POS_GAS.BRISI_PROMET( :kasa_id, to_date( :datum_prometa, ''RRRR-MM-dd"T"hh24:mi'' ) );

    :message := ''Promet obrisan!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :promet_postoji := PRA_POS_GAS.POSTOJI_PROMET( :kasa_id,
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'promet_postoji',
      p_bind_variable_name => 'promet_postoji',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_datum_od date;
    l_datum_do date;

    /**
    * POST BODY PARAMETRI:
    *   datum_od,
    *   datum_do
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    l_datum_od := to_date(:datum_od, ''RRRR-MM-dd"T"hh24:mi'');
    l_datum_do := to_date(:datum_do, ''RRRR-MM-dd"T"hh24:mi'');

    :promet := pra_pos_gas.PROMET_ZA_RAZDOBLJE(
        :kasa_id, l_datum_od, l_datum_do
    );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'promet',
      p_bind_variable_name => 'promet',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/promet_razdoblje/postoji',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/suma',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/suma',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :suma_racuna := PRA_POS_GAS.SUMA_RACUNA(
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :kasa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'suma_racuna',
      p_bind_variable_name => 'suma_racuna',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/suma',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :ukupan_broj_racuna := PRA_POS_GAS.BROJ_RACUNA(
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :kasa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'ukupan_broj_racuna',
      p_bind_variable_name => 'ukupan_broj_racuna',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'kase/{kasa_id}/racuni/ukupan_broj',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'konobar',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'konobar',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   konobar_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :konobar := PRA_POS_GAS.POSTOJI_KONOBAR(:konobar_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'konobar',
      p_bind_variable_name => 'konobar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'konobar',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'mjesto_troska',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'mjesto_troska',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   mt_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :mjesto_troska := PRA_POS_GAS.POSTOJI_MT(:mt_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'mjesto_troska',
      p_bind_variable_name => 'mjesto_troska',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'mjesto_troska',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'porezna_isporuka',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'porezna_isporuka',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   porezna_isporuka_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :porezna_isporuka := PRA_POS_GAS.POSTOJI_PISPORUKA(:porezna_isporuka_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'porezna_isporuka',
      p_bind_variable_name => 'porezna_isporuka',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'porezna_isporuka',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE

    -- zaglavlje
    l_GODINA VARCHAR2(5);
    l_KASE_ID NUMBER;
    l_RBR VARCHAR2(50);
    l_DATUM VARCHAR2(30);
    l_KON_ID NUMBER;
    l_NAC_ID NUMBER;
    l_VPLA_ID NUMBER;
    l_POPUST NUMBER;
    l_OPIS VARCHAR2(100);
    l_VRIJEME VARCHAR2(5);
    l_OJ_ID NUMBER;
    l_SJ_ID NUMBER;
    l_AGE_ID NUMBER;
    l_BR_GOSTIJU NUMBER;
    l_PKAADR_ID NUMBER;
    l_VPDOG_ID NUMBER;
    l_GODINA_STO VARCHAR2(4);
    l_RBR_STO VARCHAR2(10);
    l_JIR VARCHAR2(40);
    l_ZASTITNI_KOD VARCHAR2(40);
    l_PARAGON VARCHAR2(50);
    l_PARAGON_SET VARCHAR2(50);
    l_PARAGON_SERIJA VARCHAR2(50);
    l_BR_LOY_KARTICE VARCHAR2(50);
    l_BR_KARTICE VARCHAR2(50);
    L_BR_STOLA NUMBER;
    L_IZNOS_PLACANJA NUMBER;
    L_IZNOS_PLACANJA_2 NUMBER;
    L_VPLA_2_ID NUMBER;

    -- stavka
    l_rbr_stavke NUMBER;
    l_pro_sifra_stavke VARCHAR2(50);
    l_sifgr_id_stavke NUMBER;
    l_gpor_id_stavke NUMBER;
    l_mt_id_stavke NUMBER;
    l_kolicina_stavke NUMBER;
    l_cijena_stavke NUMBER;
    l_pdv_stavke NUMBER;
    l_ppot_stavke NUMBER;
    l_vpispz_id_stavke NUMBER;
    l_popust_stavke NUMBER;
    l_iznos_popust_stavke NUMBER;
    l_matkalk_id_stavke NUMBER;
    l_pro_id_stavke NUMBER;
    l_iznos_pdv_stavke NUMBER;
    l_iznos_ppot_stavke NUMBER;
    l_iznos_stavke NUMBER;
    l_iznos_pnaknade_stavke NUMBER;
    l_zmpdje_id_stavke NUMBER;


    l_insert_header varchar2(500);


    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_test VARCHAR2(50);

    l_broj_racuna NUMBER;
    l_broj_stavaka number;

    l_racun VARCHAR2(500);
    l_stavka VARCHAR2(500);

    l_rezultat varchar2 (500);

    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_values apex_json.t_values;

    /**
    * POST BODY PARAMETRI:
    *{
        "racuni": [
		{
			"godina": "2017",
			"kase_id": 5067,
			"rbr": "000009",
			"datum": "08.11.27",
			"kon_id": 7042,
			"nac_id": 474,
			"vpla_id": 1,
			"popust": 0,
			"opis": "TURISTIČKA ZAJEDNICA DONJA STUBICA",
			"vrijeme": "0000",
			"oj_id": 5064,
			"sj_id": 93,
			"age_id": 311,
			"br_gostiju": 1,
			"pkaadr_ozn": null,
			"vpdog_id": null,
			"GODINA_STO": null,
			"RBR_STO": null,
			"jir": null,
			"zastitni_kod": null,
			"paragon": null,
			"paragon_set": null,
			"paragon_serija": null,
			"BR_LOY_KARTICE": null,
			"BR_KARTICE": null,
            "iznos_placanja": 12,
            "iznos_placanja_2": null,
            "vrsta_placanja_2_id": null,
			"stavke": [
				{
					"rbr_stavke": 1,
					"pro_sifra": "2214",
					"sifgr_id": null,
					"gpor_id": 153,
					"mt_id": 5064,
					"kolicina": 2,
					"cijena": 22.00,
					"pdv": 25,
					"ppot": 3,
					"vpispz": null,
					"popust": 0,
					"iznos_popust": 0,
					"matkalk_id": null,
					"pro_id": 828,
					"iznos_pdv": 10.00,
					"iznos_ppot": 6.00,
					"iznos": 30.00,
					"iznos_pnaknade": 0,
					"iznos_marze": 0,
					"iznos_pdv_marze": 0,
					"stopa_pdv_marze": 0,
					"zmpdje_id": null
				}
                ]
            }
            ]
        }
        */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    END IF;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);


    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        l_GODINA := apex_json.get_varchar2(p_path => ''[%d].godina'', p0 => racun, p_values => l_values);
        l_KASE_ID := apex_json.get_number(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        l_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        l_DATUM := apex_json.get_varchar2(p_path => ''[%d].datum'', p0 => racun, p_values => l_values);
        l_KON_ID := apex_json.get_number(p_path => ''[%d].kon_id'', p0 => racun, p_values => l_values);
        l_NAC_ID := apex_json.get_number(p_path => ''[%d].nac_id'', p0 => racun, p_values => l_values);
        l_VPLA_ID := apex_json.get_number(p_path => ''[%d].vpla_id'', p0 => racun, p_values => l_values);
        l_POPUST := apex_json.get_number(p_path => ''[%d].popust'', p0 => racun, p_values => l_values);
        l_OPIS := apex_json.get_varchar2(p_path => ''[%d].opis'', p0 => racun, p_values => l_values);
        l_VRIJEME := apex_json.get_varchar2(p_path => ''[%d].vrijeme'', p0 => racun, p_values => l_values);
        l_OJ_ID := apex_json.get_number(p_path => ''[%d].oj_id'', p0 => racun, p_values => l_values);
        l_SJ_ID := apex_json.get_number(p_path => ''[%d].sj_id'', p0 => racun, p_values => l_values);
        l_AGE_ID := apex_json.get_number(p_path => ''[%d].age_id'', p0 => racun, p_values => l_values);
        l_BR_GOSTIJU := apex_json.get_number(p_path => ''[%d].broj_gastro_gostiju'', p0 => racun, p_values => l_values);
        l_PKAADR_ID := apex_json.get_number(p_path => ''[%d].pkaadr_ozn'', p0 => racun, p_values => l_values);
        l_VPDOG_ID := apex_json.get_number(p_path => ''[%d].vpdog_id'', p0 => racun, p_values => l_values);
        l_GODINA_STO := apex_json.get_varchar2(p_path => ''[%d].godina_sto'', p0 => racun, p_values => l_values);
        l_RBR_STO := apex_json.get_varchar2(p_path => ''[%d].rbr_sto'', p0 => racun, p_values => l_values);
        l_JIR := apex_json.get_varchar2(p_path => ''[%d].jir'', p0 => racun, p_values => l_values);
        l_ZASTITNI_KOD := apex_json.get_varchar2(p_path => ''[%d].zastitni_kod'', p0 => racun, p_values => l_values);
        l_PARAGON := apex_json.get_varchar2(p_path => ''[%d].paragon'', p0 => racun, p_values => l_values);
        l_PARAGON_SET := apex_json.get_varchar2(p_path => ''[%d].paragon_set'', p0 => racun, p_values => l_values);
        l_PARAGON_SERIJA := apex_json.get_varchar2(p_path => ''[%d].paragon_serija'', p0 => racun, p_values => l_values);
        l_BR_LOY_KARTICE := apex_json.get_varchar2(p_path => ''[%d].broj_loy_kartice'', p0 => racun, p_values => l_values);
        l_BR_KARTICE := apex_json.get_varchar2(p_path => ''[%d].broj_kartice'', p0 => racun, p_values => l_values);
        L_BR_STOLA := apex_json.get_number(p_path => ''[%d].br_stola'', p0 => racun, p_values => l_values);
        L_IZNOS_PLACANJA := apex_json.get_number(p_path => ''[%d].iznos_placanja'', p0 => racun, p_values => l_values);
        L_IZNOS_PLACANJA_2 := apex_json.get_number(p_path => ''[%d].iznos_placanja_2'', p0 => racun, p_values => l_values);
        L_VPLA_2_ID := apex_json.get_number(p_path => ''[%d].vrsta_placanja_2_id'', p0 => racun, p_values => l_values);

        pra_pos_gas.UCITAJ_RNKASE(  l_GODINA,
                                    l_KASE_ID ,
                                    l_RBR ,
                                    to_date(l_DATUM, ''RRRR-MM-dd"T"hh24:mi'') ,
                                    l_KON_ID ,
                                    l_NAC_ID ,
                                    l_VPLA_ID ,
                                    l_POPUST ,
                                    l_OPIS ,
                                    l_VRIJEME ,
                                    l_OJ_ID ,
                                    l_SJ_ID ,
                                    l_AGE_ID ,
                                    l_BR_GOSTIJU ,
                                    l_PKAADR_ID ,
                                    l_VPDOG_ID ,
                                    l_GODINA_STO ,
                                    l_RBR_STO ,
                                    l_JIR ,
                                    l_ZASTITNI_KOD ,
                                    l_PARAGON ,
                                    l_PARAGON_SET ,
                                    l_PARAGON_SERIJA ,
                                    l_BR_LOY_KARTICE ,
                                    l_BR_KARTICE ,
                                    L_BR_STOLA,
                                    L_VPLA_2_ID,
                                    L_IZNOS_PLACANJA,
                                    L_IZNOS_PLACANJA_2);


        l_broj_stavaka := apex_json.get_count(p_path => ''[%d].stavke'', p0 => racun, p_values => l_values);

        FOR stavka IN 1 .. nvl(l_broj_stavaka,-1) LOOP

            l_rbr_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].rbr_stavke'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pro_sifra_stavke := apex_json.get_VARCHAR2(p_path => ''[%d].stavke[%d].pro_sifra'', p0 => racun, p1 => stavka, p_values => l_values);
            l_sifgr_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].sifgr_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_gpor_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].gpor_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_mt_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].mt_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_kolicina_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].kolicina'', p0 => racun, p1 => stavka, p_values => l_values);
            l_cijena_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].cijena'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pdv_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].pdv'', p0 => racun, p1 => stavka, p_values => l_values);
            l_ppot_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].ppot'', p0 => racun, p1 => stavka, p_values => l_values);
            l_vpispz_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].vpispz'', p0 => racun, p1 => stavka, p_values => l_values);
            l_popust_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].popust'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_popust_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_popust'', p0 => racun, p1 => stavka, p_values => l_values);
            l_matkalk_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].matkalk_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_pro_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].pro_id'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_pdv_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_pdv'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_ppot_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_ppot'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos'', p0 => racun, p1 => stavka, p_values => l_values);
            l_iznos_pnaknade_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].iznos_pnaknade'', p0 => racun, p1 => stavka, p_values => l_values);
            l_zmpdje_id_stavke := apex_json.get_number(p_path => ''[%d].stavke[%d].zmpdje_id'', p0 => racun, p1 => stavka, p_values => l_values);

            pra_pos_gas.ucitaj_rnkase_pro(l_GODINA,
                                        l_KASE_ID,
                                        l_RBR,
                                        l_rbr_stavke,
                                        l_pro_sifra_stavke,
                                        l_sifgr_id_stavke,
                                        l_gpor_id_stavke,
                                        l_mt_id_stavke,
                                        l_kolicina_stavke,
                                        l_cijena_stavke,
                                        l_pdv_stavke,
                                        l_ppot_stavke,
                                        l_vpispz_id_stavke,
                                        l_popust_stavke,
                                        l_matkalk_id_stavke,
                                        l_pro_id_stavke,
                                        l_iznos_stavke,
                                        l_iznos_popust_stavke,
                                        l_iznos_pdv_stavke,
                                        l_iznos_ppot_stavke,
                                        l_iznos_pnaknade_stavke,
                                        l_zmpdje_id_stavke);

        end loop;

    END LOOP;

    :message := ''Podaci su uspješno upisani '' || l_broj_racuna;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

end;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vrijednost_parametra := PRA_POS_GAS.ZMPPAR_VRIJEDNOST(:sustav_sifra, :parametar_sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'parametar_sifra',
      p_bind_variable_name => 'parametar_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'sustav_sifra',
      p_bind_variable_name => 'sustav_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'vrijednost_parametra_sustava',
      p_bind_variable_name => 'vrijednost_parametra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'sustavi/{sustav_sifra}/parametri/{parametar_sifra}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpdogadjaja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpdogadjaja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vpdogadjaja := PRA_POS_GAS.VPDOGADJAJA;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznih_dogadjaja',
      p_bind_variable_name => 'vpdogadjaja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukap_vpdogadjaja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukap_vpdogadjaja',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vpisporukap_vpdogadjaja := PRA_POS_GAS.VPISPORUKAP_VPDOGADJAJA;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'vrste_poreznih_isporuka_dogadjaja',
      p_bind_variable_name => 'vpisporukap_vpdogadjaja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukap_vpdogadjaja',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukaz',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vpisporukaz',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  25,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vpisporukaz := PRA_POS_GAS.VPISPORUKAZ;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'vrste_porezne_isporuke',
      p_bind_variable_name => 'vpisporukaz',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vpisporukaz',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vplacanja',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_gas',
      p_pattern        => 'vplacanja',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   vplacanja_id
    *   sifra
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :vrsta_placanja := PRA_POS_GAS.POSTOJI_VPLACANJA(:vplacanja_id, :sifra);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'Korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'Lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'vrsta_placanja',
      p_bind_variable_name => 'vrsta_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_gas',
      p_pattern            => 'vplacanja',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_ip',
      p_base_path      => '/pra_pos_ip/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_ip',
      p_pattern        => 'account',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_ip',
      p_pattern        => 'account',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   kasa_id
    *   pos_godina
    *   pos_rbr
    *   datum
    *   oznaka_gratis
    *   datum_isteka
    *   broj_minuta
    *   smjestajni_objekt_id
    *   gost_id
    *   unos_korisnik
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_IP.CREATE_ACCOUNT( :kasa_id, :pos_godina, :pos_rbr,
        to_date( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :oznaka_gratis,
        to_date( :datum_isteka, ''RRRR-MM-dd"T"hh24:mi'' ), :broj_minuta,
        :smjestajni_objekt_id, :gost_id, :unos_korisnik, :username, :password,
        :napomena );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'napomena',
      p_bind_variable_name => 'napomena',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'password',
      p_bind_variable_name => 'password',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'username',
      p_bind_variable_name => 'username',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_ip',
      p_pattern        => 'account',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_IP.SUSPEND_ACCOUNT( :kasa_id, :pos_godina,
        :pos_rbr, TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :smjestajni_objekt_id,
        :unos_korisnik, :username, :row_count );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'row_count',
      p_bind_variable_name => 'row_count',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_ip',
      p_pattern            => 'account',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_pka',
      p_base_path      => '/pra_pos_pka/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'adrese',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'adrese',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:adrese := PRA_POS_PKA.ADRESE( :organizacijska_jedinica_id, trunc(sysdate), :filter );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'adrese',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'agencije',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'agencije',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:agencije := PRA_POS_PKA.AGENCIJE(:filter);

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'agencije',
      p_bind_variable_name => 'agencije',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'agencije',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'aranzmani',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'aranzmani',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:aranzmani := PRA_POS_PKA.ARANZMANI;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'aranzmani',
      p_bind_variable_name => 'aranzmani',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'aranzmani',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:banke := PRA_POS_PKA.BANKE;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'banke',
      p_bind_variable_name => 'banke',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke/{banka_id}/valute',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'banke/{banka_id}/valute',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:valute := PRA_POS_PKA.VALUTE( :banka_id,
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'banka_id',
      p_bind_variable_name => 'banka_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'valute',
      p_bind_variable_name => 'valute',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'banke/{banka_id}/valute',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'gosti',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'gosti',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_datum date;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );
    l_datum := trunc(to_date( :datum, ''RRRR-MM-dd"T"hh24:mi'' ));

	:gosti := PRA_POS_PKA.GOSTI( :smjestajni_objekt_id,
        l_datum, :kasa_id, :filter );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'gosti',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'kartice/{kartica_id}/limit',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'kartice/{kartica_id}/limit',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_kartica_id number;

    /**
    * POST BODY PARAMETRI:
    *   adresa_id
    *   cjenik_id
    *   poslovna_godina
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    if :kartica_id = ''null'' then
        l_kartica_id := null;
    else
        l_kartica_id := to_number(:kartica_id);
    end if;

	PRA_POS_PKA.PROVJERI_LIMIT( :adresa_id, l_kartica_id, :cjenik_id,
        :poslovna_godina, :oznaka, :iznos );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'iznos',
      p_bind_variable_name => 'iznos',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'oznaka',
      p_bind_variable_name => 'oznaka',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'kartice/{kartica_id}/limit',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'loyalty_clanovi/{broj_kartice}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'loyalty_clanovi/{broj_kartice}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:loyalty_clanovi := PRA_POS_PKA.LOY_CLAN( :broj_kartice );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'loyalty_clanovi',
      p_bind_variable_name => 'loyalty_clanovi',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'loyalty_clanovi/{broj_kartice}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:organizacijske_jedinice := PRA_POS_PKA.ZMPOJR;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'organizacijske_jedinice',
      p_bind_variable_name => 'organizacijske_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:adrese := PRA_POS_PKA.PKAADR_BY_ID( :organizacijska_jedinica_id, :adresa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE

    -- racun
    L_ZMPOJR_ID NUMBER;
    L_GMPKAS_ID NUMBER;
    L_VPLA_ID number;
    L_GOSTP_ID NUMBER;
    L_AGEP_ID number;
    L_PKAADRP_ID NUMBER;
    L_GOD_POSLOVNA VARCHAR2(5);
    L_RBR VARCHAR2(20);
    L_DATUM varchar2(20);
    L_IZN_PLACANJA number;
    L_IZN_TECAJA number;
    L_IZN_PPOT NUMBER;
    L_OPIS1 VARCHAR2(50);
    L_OPIS2 varchar2(50);
    L_RECARA_ID number;
    L_VPDOG_ID number;
    L_NAC_ID number;
    L_STOPA_PPOT number;
    L_IZN_OSNOVICE_PPOT number;
    L_PKAKAR_ID number;
    L_GOST_ID number;
    L_AGE_ID number;
    L_PKAADR_ID number;
    L_IZN_POPUSTA NUMBER;
    L_RACUN_ID number;
    L_RBR_STORNO varchar2(20);
    L_GOD_POSLOVNA_STORNO varchar2(5);
    L_VPLA2_ID number;
    L_IZN_PLACANJA2 NUMBER;

    L_PKARNK_ID number;


    -- porez
    L_POREZ_IZN_OSNOVICE NUMBER;
    L_POREZ_STOPA_PDV NUMBER;
    L_POREZ_VPISPZ_ID NUMBER;
    L_POREZ_IZN_PDV NUMBER;

    -- isporuka
    L_ISPORUKA_SIFRA VARCHAR2(10);
    L_ISPORUKA_NAZIV VARCHAR2(50);
    L_ISPORUKA_JM VARCHAR2(10);
    L_ISPORUKA_KOLICINA NUMBER;
    L_ISPORUKA_CIJENA number;
    L_ISPORUKA_STOPA_POPUSTA NUMBER;
    L_ISPORUKA_VPISPZ_ID NUMBER;
    L_ISPORUKA_STOPA_PDV NUMBER;
    L_ISPORUKA_IZN_PPOT NUMBER;
    L_ISPORUKA_IZN_PDV number;


    l_default_lang_ctx NUMBER;
    l_blob BLOB;
    l_clob clob;
    l_warning   NUMBER;
    l_offset NUMBER :=1;
    l_amount NUMBER;
    l_values apex_json.t_values;

    l_broj_racuna NUMBER;
    l_broj_stavaka_porez NUMBER;
    l_broj_stavaka_isporuka number;

    l_broj_obrisanih number;


    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    l_blob := :body;
    l_default_lang_ctx := dbms_lob.default_lang_ctx;

    IF DBMS_LOB.getlength(l_blob) = 0 THEN
        RETURN;
    ELSE
        l_amount := DBMS_LOB.GETLENGTH(l_blob);
        DBMS_LOB.OPEN(l_blob, DBMS_LOB.LOB_READONLY);

        DBMS_LOB.CREATETEMPORARY(l_clob, TRUE);
        DBMS_LOB.CONVERTTOCLOB(
        dest_lob     => l_clob,
        src_blob     => l_blob,
        amount       => l_amount,
        dest_offset  => l_offset,
        src_offset   => l_offset,
        blob_csid    => nls_charset_id(''UTF8''),
        lang_context => l_default_lang_ctx,
        warning      => l_warning);

        DBMS_LOB.CLOSE(l_blob);
    END IF;

    apex_json.parse(l_values, l_clob);

    L_ZMPOJR_ID := :organizacijska_jedinica_id;

    l_broj_racuna := apex_json.get_count(p_path => ''.'', p_values => l_values);

    FOR racun IN 1 .. nvl(l_broj_racuna,-1) LOOP

        L_RACUN_ID := apex_json.get_varchar2(p_path => ''[%d].racun_id'', p0 => racun, p_values => l_values);

        pra_pos_pka.DELETE_RACUN(L_RACUN_ID, l_broj_obrisanih);

        L_GMPKAS_ID := apex_json.get_NUMBER(p_path => ''[%d].kasa_id'', p0 => racun, p_values => l_values);
        L_VPLA_ID := apex_json.get_number(p_path => ''[%d].vrsta_placanja_id'', p0 => racun, p_values => l_values);
        L_GOSTP_ID := apex_json.get_NUMBER(p_path => ''[%d].gostp_id'', p0 => racun, p_values => l_values);
        L_AGEP_ID := apex_json.get_number(p_path => ''[%d].agencijap_id'', p0 => racun, p_values => l_values);
        L_PKAADRP_ID := apex_json.get_number(p_path => ''[%d].adresap_id'', p0 => racun, p_values => l_values);
        L_GOD_POSLOVNA := apex_json.get_varchar2(p_path => ''[%d].poslovna_godina'', p0 => racun, p_values => l_values);
        L_RBR := apex_json.get_varchar2(p_path => ''[%d].rbr'', p0 => racun, p_values => l_values);
        L_DATUM := apex_json.get_varchar2(p_path => ''[%d].datum'', p0 => racun, p_values => l_values);
        L_IZN_PLACANJA := apex_json.get_number(p_path => ''[%d].iznos_placanja'', p0 => racun, p_values => l_values);
        L_IZN_TECAJA := apex_json.get_number(p_path => ''[%d].iznos_tecaja'', p0 => racun, p_values => l_values);
        L_IZN_PPOT := apex_json.get_number(p_path => ''[%d].iznos_ppot'', p0 => racun, p_values => l_values);
        L_OPIS1 := apex_json.get_varchar2(p_path => ''[%d].opis_1'', p0 => racun, p_values => l_values);
        L_OPIS2 := apex_json.get_varchar2(p_path => ''[%d].opis_2'', p0 => racun, p_values => l_values);
        L_RECARA_ID := apex_json.get_number(p_path => ''[%d].recara_id'', p0 => racun, p_values => l_values);
        L_VPDOG_ID := apex_json.get_number(p_path => ''[%d].vrsta_poreznog_dogadaja_id'', p0 => racun, p_values => l_values);
        L_NAC_ID := apex_json.get_number(p_path => ''[%d].cjenik_id'', p0 => racun, p_values => l_values);
        L_STOPA_PPOT := apex_json.get_number(p_path => ''[%d].stopa_ppot'', p0 => racun, p_values => l_values);
        L_IZN_OSNOVICE_PPOT := apex_json.get_number(p_path => ''[%d].iznos_osnovice_ppot'', p0 => racun, p_values => l_values);
        L_PKAKAR_ID := apex_json.get_number(p_path => ''[%d].pkakar_id'', p0 => racun, p_values => l_values);
        L_GOST_ID := apex_json.get_number(p_path => ''[%d].gost_id'', p0 => racun, p_values => l_values);
        L_AGE_ID := apex_json.get_number(p_path => ''[%d].agencija_id'', p0 => racun, p_values => l_values);
        L_PKAADR_ID := apex_json.get_number(p_path => ''[%d].adresa_id'', p0 => racun, p_values => l_values);
        L_IZN_POPUSTA := apex_json.get_number(p_path => ''[%d].iznos_popusta'', p0 => racun, p_values => l_values);
        L_RBR_STORNO := apex_json.get_varchar2(p_path => ''[%d].rbr_storno'', p0 => racun, p_values => l_values);
        L_GOD_POSLOVNA_STORNO := apex_json.get_varchar2(p_path => ''[%d].godina_storno'', p0 => racun, p_values => l_values);
        L_VPLA2_ID := apex_json.get_varchar2(p_path => ''[%d].vrsta_placanja_2_id'', p0 => racun, p_values => l_values);
        L_IZN_PLACANJA2 := apex_json.get_varchar2(p_path => ''[%d].iznos_placanja_2'', p0 => racun, p_values => l_values);

        PRA_POS_PKA.INSERT_RACUN(
            L_ZMPOJR_ID,
            L_GMPKAS_ID,
            L_VPLA_ID,
            L_GOSTP_ID,
            L_AGEP_ID,
            L_PKAADRP_ID,
            L_GOD_POSLOVNA,
            L_RBR,
            to_date(L_DATUM, ''RRRR-MM-dd"T"hh24:mi''), --2017-11-16T00:00
            L_IZN_PLACANJA,
            L_IZN_TECAJA,
            L_IZN_PPOT,
            L_OPIS1,
            L_OPIS2,
            L_RECARA_ID,
            L_VPDOG_ID,
            L_NAC_ID,
            L_STOPA_PPOT,
            L_IZN_OSNOVICE_PPOT,
            L_PKAKAR_ID,
            L_GOST_ID,
            L_AGE_ID,
            L_PKAADR_ID,
            L_IZN_POPUSTA,
            L_GOD_POSLOVNA_STORNO,
            L_RBR_STORNO,
            L_VPLA2_ID,
            L_IZN_PLACANJA2,
            L_PKARNK_ID
        );

        l_broj_stavaka_porez := apex_json.get_count(p_path => ''[%d].porezi'', p0 => racun, p_values => l_values);

        FOR porez IN 1 .. nvl(l_broj_stavaka_porez,-1) LOOP
            L_POREZ_IZN_OSNOVICE := apex_json.get_number(p_path => ''[%d].porezi[%d].iznos_osnovice'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_STOPA_PDV := apex_json.get_number(p_path => ''[%d].porezi[%d].stopa_pdv'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_VPISPZ_ID := apex_json.get_number(p_path => ''[%d].porezi[%d].vrsta_porezne_isporukez_id'', p0 => racun, p1 => porez, p_values => l_values);
            L_POREZ_IZN_PDV := apex_json.get_number(p_path => ''[%d].porezi[%d].iznos_pdv'', p0 => racun, p1 => porez, p_values => l_values);

            PRA_POS_PKA.INSERT_POREZ(
                  L_ZMPOJR_ID,
                  L_PKARNK_ID,
                  L_POREZ_IZN_OSNOVICE,
                  L_POREZ_STOPA_PDV,
                  L_POREZ_VPISPZ_ID,
                  L_POREZ_IZN_PDV
            );

        end loop;

        l_broj_stavaka_isporuka := apex_json.get_count(p_path => ''[%d].pisporuke'', p0 => racun, p_values => l_values);

        FOR pisporuka IN 1 .. nvl(l_broj_stavaka_isporuka,-1) LOOP
            L_ISPORUKA_SIFRA := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].sifra'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_NAZIV := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].naziv'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_JM := apex_json.get_varchar2(p_path => ''[%d].pisporuke[%d].jm'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_KOLICINA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].kolicina'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_CIJENA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].cijena'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_STOPA_POPUSTA := apex_json.get_number(p_path => ''[%d].pisporuke[%d].stopa_popusta'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_VPISPZ_ID := apex_json.get_number(p_path => ''[%d].pisporuke[%d].vrsta_porezne_isporukez_id'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_STOPA_PDV := apex_json.get_number(p_path => ''[%d].pisporuke[%d].stopa_pdv'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_IZN_PPOT := apex_json.get_NUMBER(p_path => ''[%d].pisporuke[%d].iznos_ppot'', p0 => racun, p1 => pisporuka, p_values => l_values);
            L_ISPORUKA_IZN_PDV := apex_json.get_number(p_path => ''[%d].pisporuke[%d].iznos_pdv'', p0 => racun, p1 => pisporuka, p_values => l_values);


            PRA_POS_PKA.INSERT_PKARNKISP(
                  L_ZMPOJR_ID,
                  L_PKARNK_ID,
                  L_ISPORUKA_SIFRA,
                  L_ISPORUKA_NAZIV,
                  L_ISPORUKA_JM,
                  L_ISPORUKA_KOLICINA,
                  L_ISPORUKA_CIJENA,
                  L_ISPORUKA_STOPA_POPUSTA,
                  L_ISPORUKA_VPISPZ_ID,
                  L_ISPORUKA_STOPA_PDV,
                  L_ISPORUKA_IZN_PPOT,
                  L_ISPORUKA_IZN_PDV
            );

        end loop;

    end loop;

    :racun_id := L_PKARNK_ID;
    :broj_obrisanih := l_broj_obrisanih;

    :status := 201;

    EXCEPTION
        WHEN api_exception THEN
            ROLLBACK;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERS THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_PKA.VRATI_PKARNK( :organizacijska_jedinica_id,:racun_id, :iznos_placanja, :vrsta_placanja );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'iznos_placanja',
      p_bind_variable_name => 'iznos_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_placanja',
      p_bind_variable_name => 'vrsta_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/racuni/{racun_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'racuni/{racun_id}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    pra_pos_pka.DELETE_RACUN(:racun_id, :broj_obrisanih);

    EXCEPTION
        WHEN api_exception THEN
            rollback;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :smjestajni_objekti := PRA_POS_PKA.SO;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekti',
      p_bind_variable_name => 'smjestajni_objekti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:gosti := PRA_POS_PKA.GOST_BY_ID( :smjestajni_objekt_id, :gost_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_datum date;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    l_datum := trunc(to_date( :datum, ''RRRR-MM-dd"T"hh24:mi'' ));

	:smjestajne_jedinice := PRA_POS_PKA.SJ( :smjestajni_objekt_id,
        l_datum, :kasa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'smjestajne_jedinice',
      p_bind_variable_name => 'smjestajne_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/kase/{kasa_id}/smjestajne_jedinice',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:organizacijska_jedinica := PRA_POS_PKA.SO_OJR_ID( :smjestajni_objekt_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'organizacijska_jedinica',
      p_bind_variable_name => 'organizacijska_jedinica',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/knjiga_racuna',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:smjestajne_jedinice := PRA_POS_PKA.SJ_ZA_BROJ( :smjestajni_objekt_id, :broj_sj );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'broj_sj',
      p_bind_variable_name => 'broj_sj',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'smjestajne_jedinice',
      p_bind_variable_name => 'smjestajne_jedinice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'smjestajni_objekti/{smjestajni_objekt_id}/smjestajne_jedinice/{broj_sj}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pka',
      p_pattern        => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:vrsta_poreznog_placanja := PRA_POS_PKA.VPPLA_NAZIV( :vrsta_poreznih_placanja_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznih_placanja_id',
      p_bind_variable_name => 'vrsta_poreznih_placanja_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'vrsta_poreznog_placanja',
      p_bind_variable_name => 'vrsta_poreznog_placanja',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pka',
      p_pattern            => 'vrste_poreznih_placanja/{vrsta_poreznih_placanja_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_pkakar',
      p_base_path      => '/pra_pos_pkakar/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'agencije/{agencija_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'agencije/{agencija_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:agencije := PRA_POS_PKAKAR.AGE_BY_ID( :agencija_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'agencija_id',
      p_bind_variable_name => 'agencija_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'agencije',
      p_bind_variable_name => 'agencije',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'agencije/{agencija_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_PKAKAR.PONISTI_GANTNER_NARUKVICU( :kasa_id, :broj_kartice, :kolicinakckar, :kolicinapkakar );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kolicinakckar',
      p_bind_variable_name => 'kolicinakckar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'kolicinapkakar',
      p_bind_variable_name => 'kolicinapkakar',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'kase/{kasa_id}/gantner_narukvica/{broj_kartice}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:adrese := PRA_POS_PKAKAR.PKAADR_BY_ID( :metcvor_sifra, :adresa_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'adrese',
      p_bind_variable_name => 'adrese',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/adrese/{adresa_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:gosti := PRA_POS_PKAKAR.GOST_BY_ID( :metcvor_sifra, :gost_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gosti',
      p_bind_variable_name => 'gosti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'metcvor/{metcvor_sifra}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:broj_kartice := PRA_POS_PKAKAR.NFC_BROJ( :uuid, :gost_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'broj_kartice',
      p_bind_variable_name => 'broj_kartice',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'uuid',
      p_bind_variable_name => 'uuid',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'nfc_broj/uuid/{uuid}/gosti/{gost_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/kase/{kasa_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/kase/{kasa_id}',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   broj_kartice
    *   pin
    *   datum_zavrsetka
    *   iznos
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_PKAKAR.PROVJERI_PKAKAR( :kasa_id, :broj_kartice, :pin,
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ), :iznos, :kartica_id, :metcvor_sifra,
        :cjenik_id, :stopa_popusta_pos1, :stopa_popusta_pos2, :gost_id, :agencija_id,
        :adresa_id, :oznaka_prepaid, :neiskoristen_iznos, :ime, :prezime,
        :cjenik2_id, :organizacijska_jedinica_sifra );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'adresa_id',
      p_bind_variable_name => 'adresa_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'agencija_id',
      p_bind_variable_name => 'agencija_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'cjenik_id',
      p_bind_variable_name => 'cjenik_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'cjenik2_id',
      p_bind_variable_name => 'cjenik2_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'gost_id',
      p_bind_variable_name => 'gost_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'ime',
      p_bind_variable_name => 'ime',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'kasa_id',
      p_bind_variable_name => 'kasa_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'neiskoristen_iznos',
      p_bind_variable_name => 'neiskoristen_iznos',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_sifra',
      p_bind_variable_name => 'organizacijska_jedinica_sifra',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'oznaka_prepaid',
      p_bind_variable_name => 'oznaka_prepaid',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'prezime',
      p_bind_variable_name => 'prezime',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'stopa_popusta_pos1',
      p_bind_variable_name => 'stopa_popusta_pos1',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'stopa_popusta_pos2',
      p_bind_variable_name => 'stopa_popusta_pos2',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/kase/{kasa_id}',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   pin
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:pin_status := PRA_POS_PKAKAR.PKAKAR_PIN_OK( :kartica_id, :metcvor_sifra, :pin );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'pin_status',
      p_bind_variable_name => 'pin_status',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:treba_pin := PRA_POS_PKAKAR.PKAKAR_TREBA_PIN( :kartica_id, :metcvor_sifra );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'kartica_id',
      p_bind_variable_name => 'kartica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'metcvor_sifra',
      p_bind_variable_name => 'metcvor_sifra',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'treba_pin',
      p_bind_variable_name => 'treba_pin',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'provjera_kartice/pin/metcvor/{metcvor_sifra}/kartica/{kartica_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   kartica_id
    *   metcvor_sifra
    *   pin
    *   kasa_id
    *   poslovna_godinap
    *   redni_broj
    *   datum
    *   iznos
    *   oznaka
    *   cjenik_id
    *   iznos_racuna
    *   iznos_popusta
    */

    l_pkakar_rn_id number;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    pra_pos_pkakar.brisi_pkakarrnk(:racun_id, :broj_obrisanih);

	PRA_POS_PKAKAR.PUNI_PKAKARRNK( :kartica_id, :metcvor_sifra, :pin, :kasa_id,
        :poslovna_godinap, :redni_broj, TO_DATE( :datum, ''YYYY-MM-DD"T"HH24:MI'' ), :iznos,
        :oznaka, :organizacijska_jedinica_id, :smjestajni_objekt_id, :cjenik_id,
        :iznos_racuna, :iznos_popusta, l_pkakar_rn_id );

    :pkakar_rn_id := l_pkakar_rn_id;

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'pkakar_rn_id',
      p_bind_variable_name => 'pkakar_rn_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'smjestajni_objekt_id',
      p_bind_variable_name => 'smjestajni_objekt_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    l_pkakar_rn_id number;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    END IF;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    pra_pos_pkakar.brisi_pkakarrnk(:racun_id, :broj_obrisanih);

	PRA_POS_PKAKAR.PONISTI_PKAKARRNK( :broj_kartice,
        :organizacijska_jedinica_id, :kasa_id, :poslovna_godinapp, :rbrpp,
        :poslovna_godinap, :rbrp, TO_DATE( :datum, ''YYYY-MM-DD"T"HH24:MI'' ), :iznos,
        :oznaka, :oznaka_ponisten, :cjenik_id, :iznos_racuna, :iznos_popusta, l_pkakar_rn_id );

    :pkakar_rnk_id := l_pkakar_rn_id;

    EXCEPTION
        WHEN api_exception THEN
            rollback;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'oznaka_ponisten',
      p_bind_variable_name => 'oznaka_ponisten',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'pkakar_rnk_id',
      p_bind_variable_name => 'pkakar_rnk_id',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni/{racun_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_pkakar',
      p_pattern        => 'racuni/{racun_id}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    END IF;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    pra_pos_pkakar.brisi_pkakarrnk(:racun_id, :broj_obrisanih);

    EXCEPTION
        WHEN api_exception THEN
            ROLLBACK;
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'broj_obrisanih',
      p_bind_variable_name => 'broj_obrisanih',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'racun_id',
      p_bind_variable_name => 'racun_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_pkakar',
      p_pattern            => 'racuni/{racun_id}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      

  ORDS.DEFINE_MODULE(
      p_module_name    => 'pra_pos_wellness',
      p_base_path      => '/pra_pos_wellness/',
      p_items_per_page =>  25,
      p_status         => 'PUBLISHED',
      p_comments       => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

    :terapeuti := PRA_POS_WELLNESS.TERAPEUTI( :organizacijska_jedinica_id,
        TO_DATE( :datum, ''YYYY-MM-DD"T"HH24:MI:SS'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'organizacijska_jedinica_id',
      p_bind_variable_name => 'organizacijska_jedinica_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'terapeuti',
      p_bind_variable_name => 'terapeuti',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'organizacijske_jedinice/{organizacijska_jedinica_id}/terapeuti',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije',
      p_method         => 'POST',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

    /**
    * POST BODY PARAMETRI:
    *   datum
    */

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:wellness_rezervacije := PRA_POS_WELLNESS.WELLNESS_REZERVACIJE(
        TO_DATE( :datum, ''RRRR-MM-dd"T"hh24:mi'' ) );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'wellness_rezervacije',
      p_bind_variable_name => 'wellness_rezervacije',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije',
      p_method             => 'POST',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_TEMPLATE(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije/{rezervacija_id}',
      p_priority       => 0,
      p_etag_type      => 'HASH',
      p_etag_query     => NULL,
      p_comments       => NULL);
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije/{rezervacija_id}',
      p_method         => 'DELETE',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_WELLNESS.STORNIRAJ_REZERVACIJU( :rezervacija_id );

    :message := ''Rezervacija je uspješno stornirana!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'rezervacija_id',
      p_bind_variable_name => 'rezervacija_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'DELETE',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije/{rezervacija_id}',
      p_method         => 'PUT',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	PRA_POS_WELLNESS.POTVRDI_REZERVACIJU( :rezervacija_id, :kasa_id, :kasa_godina, :kasa_rbr );

    :message := ''Rezervacija je uspješno potvrđena!'';

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'rezervacija_id',
      p_bind_variable_name => 'rezervacija_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'PUT',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_HANDLER(
      p_module_name    => 'pra_pos_wellness',
      p_pattern        => 'rezervacije/{rezervacija_id}',
      p_method         => 'GET',
      p_source_type    => 'plsql/block',
      p_items_per_page =>  0,
      p_mimes_allowed  => '',
      p_comments       => NULL,
      p_source         => 
'DECLARE
    l_vlasnik_podatka NUMBER;

    auth_exception EXCEPTION;

    api_exception exception;

    l_ords_api number := 1.3;

BEGIN

    IF :api IS NULL OR :api <> l_ords_api THEN
        RAISE api_exception;
    end if;

    l_vlasnik_podatka := PRA_ZMP_AUTH.PROVJERI_KORISNIKA(:korisnik, :lozinka);

    IF l_vlasnik_podatka IS NULL THEN
        pra_zmp_context.set_vlasnikpodatka(NULL);
        RAISE auth_exception;
    end if;

    pra_zmp_context.set_vlasnikpodatka(l_vlasnik_podatka);
    pra_zmp_context.set_korisnik( :korisnik );

	:rezervacija := PRA_POS_WELLNESS.REZERVACIJA( :rezervacija_id );

    EXCEPTION
        WHEN api_exception THEN
            :status := 400;
            :message := ''Neispravna verzija protokola, POS: '' || :api || '', a servis: '' || l_ords_api;
        WHEN auth_exception THEN
            :status := 401;
            :message := ''invalid username or password'';
        WHEN OTHERs THEN
            rollback;
            :status := 500;
            :message := SQLERRM;

END;'
      );
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'api_version',
      p_bind_variable_name => 'api',
      p_source_type        => 'HEADER',
      p_param_type         => 'DOUBLE',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'korisnik',
      p_bind_variable_name => 'korisnik',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'lozinka',
      p_bind_variable_name => 'lozinka',
      p_source_type        => 'HEADER',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'message',
      p_bind_variable_name => 'message',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'STRING',
      p_access_method      => 'OUT',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'rezervacija',
      p_bind_variable_name => 'rezervacija',
      p_source_type        => 'RESPONSE',
      p_param_type         => 'RESULTSET',
      p_access_method      => 'OUT',
      p_comments           => NULL);
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'rezervacija_id',
      p_bind_variable_name => 'rezervacija_id',
      p_source_type        => 'URI',
      p_param_type         => 'STRING',
      p_access_method      => 'IN',
      p_comments           => NULL);      
  ORDS.DEFINE_PARAMETER(
      p_module_name        => 'pra_pos_wellness',
      p_pattern            => 'rezervacije/{rezervacija_id}',
      p_method             => 'GET',
      p_name               => 'X-APEX-STATUS-CODE',
      p_bind_variable_name => 'status',
      p_source_type        => 'HEADER',
      p_param_type         => 'INT',
      p_access_method      => 'OUT',
      p_comments           => NULL);      

  ORDS.CREATE_ROLE(p_role_name  => 'PosUserRole');

  l_roles(1)   := 'PosUserRole';
  l_modules(1) := 'pra_pos_gas';
  l_modules(2) := 'pra_pos_ip';
  l_modules(3) := 'pra_pos_pka';
  l_modules(4) := 'pra_pos_pkakar';
  l_modules(5) := 'pra_pos_wellness';
  ORDS.DEFINE_PRIVILEGE(
      p_privilege_name => 'PosUserPrivilege',
      p_roles          => l_roles,
      p_patterns       => l_patterns,
      p_modules        => l_modules,
      p_label          => '',
      p_description    => '',
      p_comments       => NULL);      
END;